/*;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  Copyright (c) 1995-1999, ADLink Technology Inc.  All rights reserved.  ;;
;;                                                                         ;;
;;      File Name : 7258int.c                                              ;;
;;      Purpose   : This sample program demonstrates how handle interrupt  ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;*/
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "dask.h"
#include "conio.h"

int int_count = 0;
I16 card = -1;
U16 out_Val = 0;

void sig1_handler(int signo)
{
    int_count++;
    system("clear");
    printf("INT count = %d\n", int_count);
    printf("press any key to generate an interrupt or press ESC for exit\n\n" );

    return;
}

int main(void)
{
    int  err;
    char temp_char;
    int  card_number = 0;

    setbuf(stdout, NULL);
    printf(" Please input the Card Index: ");
    scanf(" %d", &card_number);

    system("clear");
    printf("PCI-7258 Interrupt Sample (INT1)\n\n");
    printf("This program shows the number of occurrence of INT1 interupt.\n");
    printf("INT1 interrupt is generated by external signal from DI bit-0/bit-1.\n");
    printf("Press ESC for exit\n\n");

    int_count = 0;

    if((card = Register_Card(PCI_7258, (I16)card_number))<0){
        printf ("Can't open device file: PCI7258\n");
        exit(-1);
    }
    DO_WritePort(card,0, out_Val);
    err = DIO_SetDualInterrupt(card, INT1_EXT_SIGNAL, INT2_DISABLE, sig1_handler, NULL );
    if(err!=NoError){
        printf(" error from DIO_SetDualInterrupt : %d \n" , err );
        goto exit_after_error;
    }

    while(1){
        temp_char = getch();
        if(temp_char==0x1b)
            break;
        DO_WritePort(card, 0, 0x0);
        sleep(0);
        DO_WritePort(card, 0, 0x1);
    }

    DIO_SetDualInterrupt(card, INT1_DISABLE, INT2_DISABLE, NULL, NULL);
    DO_WritePort(card, 0, 0x0);

exit_after_error:
    if(card>=0)
        Release_Card(card);
    exit(0);
}
