/*;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  Copyright (c) 1995-1999, ADLink Technology Inc.  All rights reserved.  ;;
;;                                                                         ;;
;;      File Name : 7260int.c                                              ;;
;;      Purpose   : This sample program demonstrates how handle interrupt  ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;*/
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "dask.h"
#include "conio.h"

int int_count = 0;
I16 card = -1;
U16 out_Val = 0, COSLData;

void sig1_handler(int signo)
{
   int_count++;
   DIO_GetCOSLatchData(card, &COSLData);
   system("clear");
   printf("INT count = %d\n", int_count);
   printf("COS Latch Data = %d\n\n", COSLData);
   printf("press any key to generate an interrupt or press ESC for exit\n\n" );

   return;
}


int main(void)
{
    int  err;
    char temp_char;
    int  card_number = 0;

    setbuf(stdout, NULL);
    printf(" Please input the Card Index: ");
    scanf(" %d", &card_number);

    system("clear");
    printf("PCI-7260 Interrupt Sample (INT1)\n\n");
    printf("This program shows the number of occurrence of INT1 interupt.\n");
    printf("INT1 interrupt is generated by external signal from DI bit-0.\n");
    printf("If you connect DO bit-0 to DI bit-0, press any key can generate an interrupt.\n" );
    printf("Or press ESC for exit\n\n" );

    int_count = 0;

    if((card = Register_Card(PCI_7260, (I16)card_number))<0){
        printf("Can't open device file: PCI7260\n");
        exit(-1);
    }

    DO_WritePort(card,0, out_Val);
    err = DIO_SetDualInterrupt(card, INT1_COS, INT2_DISABLE, sig1_handler, NULL);
    if(err!=NoError){
        printf(" error from DIO_SetDualInterrupt : %d \n", err);
        goto exit_after_error;
    }

    err = DIO_SetCOSInterrupt(card, 0, 0x0001, 0, 0);
    while(1){
        temp_char = getch();
        if(temp_char==0x1b)
            break;
        out_Val = (out_Val+1)%2;
        DO_WritePort(card,0, out_Val);
        sleep(0);
        //DO_WritePort(card,0, 0x0);
    }

    DIO_SetDualInterrupt(card, INT1_DISABLE, INT2_DISABLE, NULL, NULL);
    DIO_SetCOSInterrupt(card, 0, 0, 0, 0);
    DO_WritePort(card,0, 0x0);

exit_after_error:
    if(card>=0)
        Release_Card(card);
    exit(0);
}
